%log of DCM pdf
%Copyright Ananth Ranganathan (Honda Research Institute) 2010

function v = logdcmpdf(x,stats,lh_params)
num = size(x,1);
n = sum(x,2);
a = stats.alpha;

a(a==0) = 1e-4; %to avoid infs and nans

asum = sum(a);

v = gammaln(n + 1) - sum(gammaln(x + 1),2) + num*gammaln(asum) - gammaln(n+asum) +...
    sum(gammaln(repmat(a,num,1) + x),2) - num*sum(gammaln(a));
v = sum(v);
if isnan(v),
    fprintf(1,'g(n+1)=%d s(g(x+1))=%d g(asum)=%d g(n+asum)=%d s(g(a+x))=%d s(g(a))=%d\n',...
        gammaln(n + 1), sum(gammaln(x + 1)), gammaln(asum), gammaln(n+asum),...
        sum(gammaln(a + x)), sum(gammaln(a)));
    error('logdcmpdf is NaN for sum(x)=%d asum=%d\n',n,asum);
end