%%plot the particle history
%Copyright Ananth Ranganathan (Honda Research Institute) 2010

function h = plot_particle_history(particle_history, inp_indices, startind, figh)

if nargin==4,
    %figure(figh);
    h = figh;
else
    h = figure;
end
hold on; 
title('Change-point Posterior Distribution','FontSize',14,'FontWeight','bold');
%ylim([0 320]);xlim([0 1143]);
%set(gca,'YTick',[0 20 40 60 80]*4);

index = 1;
if nargin>2 && isscalar(startind),
    inp_indices = [startind inp_indices];
else
    inp_indices = [0 inp_indices];
end
while true,
    x = []; y = []; l = [];
    for i = 1:size(particle_history, 2),
        list = particle_history(i).list;
        if size(list,2)>=index,
            if nargin > 1,
                x = [x inp_indices(i)];
            else
                x = [x i];
            end
            y = [y list(index).r];
            l = [l -list(index).p];
        end
    end
    m1 = min(l); m2 = max(l);
    if numel(l(isnan(l)))>0,
        error('Likelihood value is NaN in plot_history_particle before division\n');
    end
    if numel(l)>1,
        if m2-m1~=0,
            l = (l-m1)/(m2-m1);
        else
            l = l/m2;
        end
        if numel(l(isnan(l)))>0,
            error('Likelihood value is NaN in plot_history_particle. Denom=%d\n',m2-m1);
        end
    end
    if isempty(x) || isempty(y) || isempty(l),
        %fprintf(1,'Empty inputs in plot_particle_history\n');
        break;
    else
        for j = 1:size(x,2)-1,
            e = 1-exp(-8*l(j));
            if isnan(e),
                error('color value is NaN in plot_history_particle\n');
            end
            if y(j)<=y(j+1),
                %fprintf(1,'Drawing line from %d,%d to %d,%d\n',x(j),y(j),x(j+1),y(j+1));
                plot([x(j) x(j+1)],[y(j) y(j+1)],'Color',[e e e]);
            end
        end
        index = index + 1;
    end
end

xlabel('Time','FontSize',11,'FontWeight','bold');
ylabel('Segment Length','FontSize',11,'FontWeight','bold');