%Sparse clustering using feature sign algorithm following Lee06nips
%U contains membership
%V contains centers
function [retU, retV] = clusterSparseFeatSign(indata, ncenters, niters)

global U data;

data = indata;
[ndata, ndims] = size(data);
V = rand(ncenters, ndims) - 0.5; %rand(ncenters, ndims);
V = V - repmat(mean(V,2), 1, size(V,2));
for i = 1:ncenters,
    V(i,:) = V(i,:)/norm(V(i,:));
end

gamma = 0.0001;
noise_var = 1;
sigma = 1;
tol = 0.005;
beta = 0.4;
epsilon = 0.01;

for n = 1:niters,
    fprintf(1,'Optimization iter %d\n',n);
    
    if n==1,
        U = cgf_fitS_sc2(V', data', 'epsL1', noise_var, beta, epsilon,...
            sigma, tol, false, false, false);
        %U = l1ls_featuresign(V', data', gamma);
    else
        %U = cgf_fitS_sc2(V', data', 'epsL1', noise_var, beta, epsilon,...
        %    sigma, tol, false, false, false, U');
        U = l1ls_featuresign(V', data', gamma, U');
    end
    U(find(isnan(U)))=0;
    U = U';
    V = l2ls_learn_basis_dual(data', U', 1);
    V = V';
end

retV = V;
retU = U;